"use strict";

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var runTest = function () {
  var _ref4 = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(test) {
    var source;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            source = fs.readFileSync(test).toString();

          case 1:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this);
  }));

  return function runTest(_x) {
    return _ref4.apply(this, arguments);
  };
}();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

/**
 * Copyright (c) 2017-present, Facebook, Inc.
 * All rights reserved.
 *
 * This source code is licensed under the BSD-style license found in the
 * LICENSE file in the root directory of this source tree. An additional grant
 * of patent rights can be found in the PATENTS file in the same directory.
 */

var fs = require("fs");
var path = require("path");

var _require = require("../lib/prepack-node.js"),
    prepackSources = _require.prepackSources;

var babel = require("babel-core");
var React = require("react");
var ReactTestRenderer = require("react-test-renderer");

var _require2 = require("../lib/utils/json.js"),
    mergeAdacentJSONTextNodes = _require2.mergeAdacentJSONTextNodes;
/* eslint-disable no-undef */


var _global = global,
    expect = _global.expect,
    describe = _global.describe,
    it = _global.it;

var test_runner = require("./test-runner.js");

function runTestSuite(outputJsx) {
  var _this = this;

  var args = new test_runner.ProgramArgs(true, false, "", "", false, test_runner.LAZY_OBJECTS_RUNTIME_NAME, false, false);

  var testRoot = path.join(__dirname, "../test/serializer");
  var testCategories = fs.readdirSync(testRoot);
  var tests = {};
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = testCategories[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var dir = _step.value;
      var _iteratorNormalCompletion2 = true;
      var _didIteratorError2 = false;
      var _iteratorError2 = undefined;

      try {
        for (var _iterator2 = fs.readdirSync(dir)[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
          var name = _step2.value;

          var loc = path.join(dir, name);
          if (fs.statSync(loc).isFile()) {
            if (!(dir in tests)) tests[dir] = [];
            tests[dir].push({
              file: fs.readFileSync(loc, "utf8"),
              name: path.join("test/serializer", name),
              shortName: name
            });
          }
        }
      } catch (err) {
        _didIteratorError2 = true;
        _iteratorError2 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion2 && _iterator2.return) {
            _iterator2.return();
          }
        } finally {
          if (_didIteratorError2) {
            throw _iteratorError2;
          }
        }
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  var _loop = function _loop(_dir) {
    var files = tests[_dir];
    describe("Test Serializer " + _dir, function () {
      var _iteratorNormalCompletion3 = true;
      var _didIteratorError3 = false;
      var _iteratorError3 = undefined;

      try {
        for (var _iterator3 = files[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
          var test = _step3.value;

          if (test_runner.shouldRunTest(test, args)) {
            var _loop2 = function _loop2(optionsString, _test) {
              it(_test.shortName + " " + optionsString, _asyncToGenerator(regeneratorRuntime.mark(function _callee() {
                return regeneratorRuntime.wrap(function _callee$(_context) {
                  while (1) {
                    switch (_context.prev = _context.next) {
                      case 0:
                        return _context.abrupt("return", _test());

                      case 1:
                      case "end":
                        return _context.stop();
                    }
                  }
                }, _callee, _this);
              })));
            };

            var _iteratorNormalCompletion4 = true;
            var _didIteratorError4 = false;
            var _iteratorError4 = undefined;

            try {
              for (var _iterator4 = test_runner.testsOfFile(_test, args)[Symbol.iterator](), _step4; !(_iteratorNormalCompletion4 = (_step4 = _iterator4.next()).done); _iteratorNormalCompletion4 = true) {
                var _ref = _step4.value;

                var _ref2 = _slicedToArray(_ref, 2);

                var optionsString = _ref2[0];
                var _test = _ref2[1];

                _loop2(optionsString, _test);
              }
            } catch (err) {
              _didIteratorError4 = true;
              _iteratorError4 = err;
            } finally {
              try {
                if (!_iteratorNormalCompletion4 && _iterator4.return) {
                  _iterator4.return();
                }
              } finally {
                if (_didIteratorError4) {
                  throw _iteratorError4;
                }
              }
            }
          }
        }
      } catch (err) {
        _didIteratorError3 = true;
        _iteratorError3 = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion3 && _iterator3.return) {
            _iterator3.return();
          }
        } finally {
          if (_didIteratorError3) {
            throw _iteratorError3;
          }
        }
      }
    });
  };

  for (var _dir in tests) {
    _loop(_dir);
  }
}

function runTests(outputJsx) {
  var prepackOptions = {
    compatibility: "react-mocks",
    internalDebug: true,
    serialize: true,
    uniqueSuffix: "",
    maxStackDepth: 100,
    reactEnabled: true,
    reactOutput: outputJsx ? "jsx" : "create-element",
    inlineExpressions: true,
    simpleClosures: true,
    omitInvariants: true
  };

  function compileSourceWithPrepack(source) {
    var code = "(function(){" + source + "})()";
    var serialized = prepackSources([{ filePath: "", fileContents: code, sourceMapContents: "" }], prepackOptions);
    if (serialized == null || serialized.reactStatistics == null) {
      throw new Error("React test runner failed during serialization");
    }
    return {
      compiledSource: serialized.code,
      statistics: serialized.reactStatistics
    };
  }

  function runSource(source) {
    var transformedSource = babel.transform(source, {
      presets: ["babel-preset-react"],
      plugins: ["transform-object-rest-spread"]
    }).code;
    /* eslint-disable no-new-func */
    var fn = new Function("require", "module", transformedSource);
    var moduleShim = { exports: null };
    var requireShim = function requireShim(name) {
      switch (name) {
        case "react":
          return React;
        default:
          throw new Error("Unrecognized import: \"" + name + "\".");
      }
    };
    try {
      // $FlowFixMe flow doesn't new Function
      fn(requireShim, moduleShim);
    } catch (e) {
      console.error(transformedSource);
      throw e;
    }
    return moduleShim.exports;
  }

  /*async function runTest(directory, name) {
    let source = fs.readFileSync(path.join(reactTestRoot, directory, name)).toString();
    let { compiledSource } = compileSourceWithPrepack(source);
     let A = runSource(source);
    expect(typeof A).toBe("function");
    let B = runSource(compiledSource);
    expect(typeof B).toBe("function");
     let rendererA = ReactTestRenderer.create(null);
    let rendererB = ReactTestRenderer.create(null);
     if (A == null || B == null) {
      throw new Error("React test runner issue");
    }
    // // Use the original version of the test in case transforming messes it up.
    let { getTrials } = A;
    // // Run tests that assert the rendered output matches.
    let resultA = getTrials(rendererA, A);
    let resultB = getTrials(rendererB, B);
     // // the test has returned many values for us to check
    for (let i = 0; i < resultA.length; i++) {
      let [nameA, valueA] = resultA[i];
      let [nameB, valueB] = resultB[i];
      expect(mergeAdacentJSONTextNodes(valueB)).toEqual(mergeAdacentJSONTextNodes(valueA));
      expect(nameB).toEqual(nameA);
    }
  }
   // Jest tests
  let originalConsoleError = console.error;
   describe(`Test React (${outputJsx ? "JSX" : "create-element"})`, () => {
    describe("Functional component folding", () => {
      let directory = "functional-components";
       it("Simple", async () => {
        await runTest(directory, "simple.js");
      });
       it("Simple children", async () => {
        await runTest(directory, "simple-children.js");
      });
       it("Simple refs", async () => {
        await runTest(directory, "simple-refs.js");
      });
       it("Conditional", async () => {
        await runTest(directory, "conditional.js");
      });
       it("Key nesting", async () => {
        await runTest(directory, "key-nesting.js");
      });
       it("Key nesting 2", async () => {
        await runTest(directory, "key-nesting-2.js");
      });
       it("Key nesting 3", async () => {
        await runTest(directory, "key-nesting-3.js");
      });
       it("Key change", async () => {
        await runTest(directory, "key-change.js");
      });
       it("Component type change", async () => {
        await runTest(directory, "type-change.js");
      });
       it("Component type same", async () => {
        await runTest(directory, "type-same.js");
      });
       it("Dynamic props", async () => {
        await runTest(directory, "dynamic-props.js");
      });
       it("Dynamic context", async () => {
        await runTest(directory, "dynamic-context.js");
      });
       it("React.cloneElement", async () => {
        await runTest(directory, "clone-element.js");
      });
       it("Return text", async () => {
        await runTest(directory, "return-text.js");
      });
       it("Return undefined", async () => {
        // this test will cause a React console.error to show
        // we monkey patch it to stop it polluting the test output
        // with a false-negative error
        global.console.error = () => {};
        try {
          await runTest(directory, "return-undefined.js");
        } finally {
          global.console.error = originalConsoleError;
        }
      });
       it("Class component as root", async () => {
        await runTest(directory, "class-root.js");
      });
       it("Class component as root with multiple render methods", async () => {
        await runTest(directory, "class-root-with-render-methods.js");
      });
       it("Class component as root with props", async () => {
        await runTest(directory, "class-root-with-props.js");
      });
       it("Class component as root with state", async () => {
        await runTest(directory, "class-root-with-state.js");
      });
       it("Class component as root with refs", async () => {
        await runTest(directory, "class-root-with-refs.js");
      });
       it("Class component as root with instance variables", async () => {
        await runTest(directory, "class-root-with-instance-vars.js");
      });
       it("Class component as root with instance variables #2", async () => {
        await runTest(directory, "class-root-with-instance-vars-2.js");
      });
    });
     describe("Class component folding", () => {
      let directory = "class-components";
       it("Simple classes", async () => {
        await runTest(directory, "simple-classes.js");
      });
    });
  });*/
}

runTestSuite(true);
runTestSuite(false);
//# sourceMappingURL=jest-serializer.js.map